//+------------------------------------------------------------------+
//|   Qualitative Quantitative Estimation Indicator for Metatrader 4 |
//|                                     Copyright  2006Roman Ignatov |
//|                                   mailto:roman.ignatov@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  200 Roman Ignatov"
#property link      "mailto:roman.ignatov@gmail.com"

#property indicator_separate_window

#property indicator_buffers 3

#property indicator_color1 DeepSkyBlue
#property indicator_style1 STYLE_SOLID
#property indicator_width1 2

#property indicator_color2 LightPink
#property indicator_style2 STYLE_DOT
#property indicator_width2 1

#property indicator_color3 OrangeRed
#property indicator_style3 STYLE_SOLID
#property indicator_width3 1

#property indicator_level1 50.00
#property indicator_levelcolor DeepSkyBlue
#property indicator_levelstyle STYLE_SOLID
#property indicator_levelwidth 1



extern int SF = 5;

extern int CCI_Period = 14;

extern int CCI_Price = PRICE_CLOSE;

extern int MA_Mode = MODE_EMA;

extern double Slow = 4.236;

extern double Fast = 2.618;


int Wilders_Period;
int StartBar;

double TrLevelSlow[];
double TrLevelFast[];
double AtrCci[];
double MaAtrCci[];
double Cci[];
double CciMa[];

int init()
{
    Wilders_Period = CCI_Period * 2 - 1;
    if (Wilders_Period < SF)
        StartBar = SF;
    else
        StartBar = Wilders_Period;
        
    IndicatorBuffers(6);
    SetIndexBuffer(0, CciMa);
    SetIndexStyle(0, DRAW_LINE);
    SetIndexLabel(0, "Value 1");
    SetIndexDrawBegin(0, StartBar);
    SetIndexStyle(1, DRAW_LINE);
    SetIndexBuffer(1, TrLevelFast);
    SetIndexLabel(1, "Value 2");
    SetIndexDrawBegin(1, StartBar);
    SetIndexStyle(2, DRAW_LINE);
    SetIndexBuffer(2, TrLevelSlow);
    SetIndexLabel(2, "Value 3");
    SetIndexDrawBegin(2, StartBar);
    SetIndexBuffer(3, AtrCci);
    SetIndexBuffer(4, MaAtrCci);
    SetIndexBuffer(5, Cci);
    IndicatorShortName(StringConcatenate("QQE_CCI(", SF, ")"));
    return(0);
}


int start()
{
    int counted, i;
    double cci0, cci1, dar, tr, dv;
    double cci2, dar2, tr2, dv2;
    
    if(Bars <= StartBar)
        return (0);

    counted = IndicatorCounted();
    if(counted < 1)
        for(i = Bars - StartBar; i < Bars; i++)
        {
            TrLevelSlow[i] = 0.0;
            TrLevelFast[i] = 0.0;
            AtrCci[i] = 0.0;
            MaAtrCci[i] = 0.0;
            Cci[i] = 0.0;
            CciMa[i] = 0.0;
        }
    
    counted = Bars - counted - 1;
        
    for (i = counted; i >= 0; i--)
        Cci[i] = iCCI(NULL, 0, CCI_Period, CCI_Price, i);

    for (i = counted; i >= 0; i--)
    {
        CciMa[i] = iMAOnArray(Cci, 0, SF, 0, MA_Mode, i);
        AtrCci[i] = MathAbs(CciMa[i + 1] - CciMa[i]);
    }

    for (i = counted; i >= 0; i--)
        MaAtrCci[i] = iMAOnArray(AtrCci, 0, Wilders_Period, 0, MA_Mode, i);

    i = counted + 1;
    tr = TrLevelSlow[i];
    tr2 = TrLevelFast[i];
    cci1 = iMAOnArray(Cci, 0, SF, 0, MA_Mode, i);
    cci2 = iMAOnArray(Cci, 0, SF, 0, MA_Mode, i);
    while (i > 0)
    {
        i--;
        cci0 = iMAOnArray(Cci, 0, SF, 0, MA_Mode, i);
        dar = iMAOnArray(MaAtrCci, 0, Wilders_Period, 0, MA_Mode, i) * Slow;

        dv = tr;
        if (cci0 < tr)
        {
            tr = cci0 + dar;
            if (cci1 < dv)
                if (tr > dv)
                    tr = dv;
        }
        else if (cci0 > tr)
        {
            tr = cci0 - dar;
            if (cci1 > dv)
                if (tr < dv)
                    tr = dv;
        }
        TrLevelSlow[i] = tr;
        cci1 = cci0;

        dar2 = iMAOnArray(MaAtrCci, 0, Wilders_Period, 0, MA_Mode, i) * Fast; 
        dv2 = tr2;
        if (cci0 < tr2)
        {
            tr2 = cci0 + dar2;
            if (cci2 < dv2)
                if (tr2 > dv2)
                    tr2 = dv2;
        }
        else if (cci0 > tr2)
        {
            tr2 = cci0 - dar2;
            if (cci2 > dv2)
                if (tr2 < dv2)
                    tr2 = dv2;
        }
        TrLevelFast[i] = tr2;
        cci2 = cci0;

    }
    
    return(0);
}


